import { useEffect } from "react";
import { useStateRef } from "powerhooks";
import { useConstCallback } from "powerhooks/useConstCallback";
export function useIntersectionObserver(params) {
    var rootMargin = params.rootMargin, root = params.root, threshold = params.threshold;
    var ref = useStateRef(null);
    var callback = useConstCallback(params.callback);
    useEffect(function () {
        if (ref.current === null) {
            return;
        }
        var observer = new IntersectionObserver(function (entries) {
            callback({
                "entry": entries[0],
                observer: observer,
            });
        }, {
            rootMargin: rootMargin,
            root: root,
            threshold: threshold,
        });
        observer.observe(ref.current);
        return function () {
            observer.disconnect();
        };
    }, [rootMargin, root, threshold, ref.current]);
    return { ref: ref };
}
//# sourceMappingURL=useIntersectionObserver.js.map