var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g = Object.create((typeof Iterator === "function" ? Iterator : Object).prototype);
    return g.next = verb(0), g["throw"] = verb(1), g["return"] = verb(2), typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
import { useEffect, useState } from "react";
import { useStateRef } from "powerhooks/useStateRef";
export function useNumberCountUpAnimation(params) {
    var number = params.number, intervalMs = params.intervalMs;
    var _a = __read(useState(0), 2), renderedNumber = _a[0], setRenderedNumber = _a[1];
    var ref = useStateRef(null);
    useEffect(function () {
        var element = ref.current;
        if (!element) {
            animate({
                number: number,
                intervalMs: intervalMs,
                setRenderedNumber: setRenderedNumber,
            });
            return;
        }
        var observer = new IntersectionObserver(function (entries) {
            if (!entries[0].isIntersecting) {
                return;
            }
            animate({ number: number, intervalMs: intervalMs, setRenderedNumber: setRenderedNumber });
            observer.unobserve(entries[0].target);
        });
        observer.observe(element);
    }, [number]);
    return { renderedNumber: renderedNumber, ref: ref };
}
var animate = (function () {
    var awaitDelay = function (params) {
        return new Promise(function (resolve) { return setTimeout(resolve, params.delayMs); });
    };
    function animate(params) {
        return __awaiter(this, void 0, void 0, function () {
            var intervalMs, number, setRenderedNumber, currentIntervalMs, _loop_1, count;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        intervalMs = params.intervalMs, number = params.number, setRenderedNumber = params.setRenderedNumber;
                        if (number === undefined) {
                            return [2 /*return*/];
                        }
                        currentIntervalMs = intervalMs;
                        _loop_1 = function (count) {
                            return __generator(this, function (_b) {
                                switch (_b.label) {
                                    case 0: return [4 /*yield*/, awaitDelay({
                                            "delayMs": (function () {
                                                if ((number < 40 && count <= number - 7) ||
                                                    (number >= 40 && count <= number - 14)) {
                                                    return currentIntervalMs;
                                                }
                                                return (currentIntervalMs += 10);
                                            })(),
                                        })];
                                    case 1:
                                        _b.sent();
                                        setRenderedNumber(count);
                                        return [2 /*return*/];
                                }
                            });
                        };
                        count = 0;
                        _a.label = 1;
                    case 1:
                        if (!(count <= number)) return [3 /*break*/, 4];
                        return [5 /*yield**/, _loop_1(count)];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        count++;
                        return [3 /*break*/, 1];
                    case 4: return [2 /*return*/];
                }
            });
        });
    }
    return { animate: animate };
})().animate;
//# sourceMappingURL=useNumberCountUpAnimation.js.map